/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import io.swagger.client.model.Ask;
import io.swagger.client.model.Bid;
import java.util.*;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * 마켓에 대한 정보
 **/
@ApiModel(description = "마켓에 대한 정보")
public class Market {
  
  @SerializedName("id")
  private String id = null;
  @SerializedName("name")
  private String name = null;
  @SerializedName("order_types")
  private List<String> orderTypes = null;
  @SerializedName("order_sides")
  private List<String> orderSides = null;
  @SerializedName("bid")
  private Bid bid = null;
  @SerializedName("ask")
  private Ask ask = null;
  @SerializedName("max_total")
  private String maxTotal = null;
  @SerializedName("state")
  private String state = null;

  /**
   * 마켓 ID
   **/
  @ApiModelProperty(value = "마켓 ID")
  public String getId() {
    return id;
  }
  public void setId(String id) {
    this.id = id;
  }

  /**
   * 마켓 이름
   **/
  @ApiModelProperty(value = "마켓 이름")
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  /**
   * 지원 주문 방식
   **/
  @ApiModelProperty(value = "지원 주문 방식")
  public List<String> getOrderTypes() {
    return orderTypes;
  }
  public void setOrderTypes(List<String> orderTypes) {
    this.orderTypes = orderTypes;
  }

  /**
   * 지원 주문 종류
   **/
  @ApiModelProperty(value = "지원 주문 종류")
  public List<String> getOrderSides() {
    return orderSides;
  }
  public void setOrderSides(List<String> orderSides) {
    this.orderSides = orderSides;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Bid getBid() {
    return bid;
  }
  public void setBid(Bid bid) {
    this.bid = bid;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Ask getAsk() {
    return ask;
  }
  public void setAsk(Ask ask) {
    this.ask = ask;
  }

  /**
   * 최대 매도/매수 금액
   **/
  @ApiModelProperty(value = "최대 매도/매수 금액")
  public String getMaxTotal() {
    return maxTotal;
  }
  public void setMaxTotal(String maxTotal) {
    this.maxTotal = maxTotal;
  }

  /**
   * 마켓 운영 상태
   **/
  @ApiModelProperty(value = "마켓 운영 상태")
  public String getState() {
    return state;
  }
  public void setState(String state) {
    this.state = state;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Market market = (Market) o;
    return (this.id == null ? market.id == null : this.id.equals(market.id)) &&
        (this.name == null ? market.name == null : this.name.equals(market.name)) &&
        (this.orderTypes == null ? market.orderTypes == null : this.orderTypes.equals(market.orderTypes)) &&
        (this.orderSides == null ? market.orderSides == null : this.orderSides.equals(market.orderSides)) &&
        (this.bid == null ? market.bid == null : this.bid.equals(market.bid)) &&
        (this.ask == null ? market.ask == null : this.ask.equals(market.ask)) &&
        (this.maxTotal == null ? market.maxTotal == null : this.maxTotal.equals(market.maxTotal)) &&
        (this.state == null ? market.state == null : this.state.equals(market.state));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.id == null ? 0: this.id.hashCode());
    result = 31 * result + (this.name == null ? 0: this.name.hashCode());
    result = 31 * result + (this.orderTypes == null ? 0: this.orderTypes.hashCode());
    result = 31 * result + (this.orderSides == null ? 0: this.orderSides.hashCode());
    result = 31 * result + (this.bid == null ? 0: this.bid.hashCode());
    result = 31 * result + (this.ask == null ? 0: this.ask.hashCode());
    result = 31 * result + (this.maxTotal == null ? 0: this.maxTotal.hashCode());
    result = 31 * result + (this.state == null ? 0: this.state.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class Market {\n");
    
    sb.append("  id: ").append(id).append("\n");
    sb.append("  name: ").append(name).append("\n");
    sb.append("  orderTypes: ").append(orderTypes).append("\n");
    sb.append("  orderSides: ").append(orderSides).append("\n");
    sb.append("  bid: ").append(bid).append("\n");
    sb.append("  ask: ").append(ask).append("\n");
    sb.append("  maxTotal: ").append(maxTotal).append("\n");
    sb.append("  state: ").append(state).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
