# swagger_client

SwaggerClient - the Ruby gem for the Upbit Open API

## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.RubyClientCodegen
For more information, please visit [https://github.com/uJhin](https://github.com/uJhin)

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build swagger_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./swagger_client-1.0.0.gem
```
(for development, run `gem install --dev ./swagger_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'swagger_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/YOUR_GIT_USERNAME/YOUR_GIT_REPO, then add the following in the Gemfile:

    gem 'swagger_client', :git => 'https://github.com/YOUR_GIT_USERNAME/YOUR_GIT_REPO.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'swagger_client'

# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: Bearer
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = SwaggerClient::APIKeyApi.new

begin
  #API 키 리스트 조회
  result = api_instance.a_pi_key_info
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling APIKeyApi->a_pi_key_info: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://api.upbit.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SwaggerClient::APIKeyApi* | [**a_pi_key_info**](docs/APIKeyApi.md#a_pi_key_info) | **GET** /api_keys | API 키 리스트 조회
*SwaggerClient::AccountApi* | [**account_info**](docs/AccountApi.md#account_info) | **GET** /accounts | 전체 계좌 조회
*SwaggerClient::AccountApi* | [**account_wallet**](docs/AccountApi.md#account_wallet) | **GET** /status/wallet | 입출금 현황
*SwaggerClient::CandleApi* | [**candle_days**](docs/CandleApi.md#candle_days) | **GET** /candles/days | 시세 캔들 조회 (일 단위)
*SwaggerClient::CandleApi* | [**candle_minutes**](docs/CandleApi.md#candle_minutes) | **GET** /candles/minutes/{unit} | 시세 캔들 조회 (분 단위)
*SwaggerClient::CandleApi* | [**candle_month**](docs/CandleApi.md#candle_month) | **GET** /candles/months | 시세 캔들 조회 (월 단위)
*SwaggerClient::CandleApi* | [**candle_weeks**](docs/CandleApi.md#candle_weeks) | **GET** /candles/weeks | 시세 캔들 조회 (주 단위)
*SwaggerClient::DepositApi* | [**deposit_coin_address**](docs/DepositApi.md#deposit_coin_address) | **GET** /deposits/coin_address | 개별 입금 주소 조회
*SwaggerClient::DepositApi* | [**deposit_coin_addresses**](docs/DepositApi.md#deposit_coin_addresses) | **GET** /deposits/coin_addresses | 전체 입금 주소 조회
*SwaggerClient::DepositApi* | [**deposit_generate_coin_address**](docs/DepositApi.md#deposit_generate_coin_address) | **POST** /deposits/generate_coin_address | 입금 주소 생성 요청
*SwaggerClient::DepositApi* | [**deposit_info**](docs/DepositApi.md#deposit_info) | **GET** /deposit | 개별 입금 조회
*SwaggerClient::DepositApi* | [**deposit_info_all**](docs/DepositApi.md#deposit_info_all) | **GET** /deposits | 입금 리스트 조회
*SwaggerClient::MarketApi* | [**market_info_all**](docs/MarketApi.md#market_info_all) | **GET** /market/all | 마켓 코드 조회
*SwaggerClient::OrderApi* | [**order_cancel**](docs/OrderApi.md#order_cancel) | **DELETE** /order | 주문 취소 접수
*SwaggerClient::OrderApi* | [**order_chance**](docs/OrderApi.md#order_chance) | **GET** /orders/chance | 주문 가능 정보
*SwaggerClient::OrderApi* | [**order_info**](docs/OrderApi.md#order_info) | **GET** /order | 개별 주문 조회
*SwaggerClient::OrderApi* | [**order_info_all**](docs/OrderApi.md#order_info_all) | **GET** /orders | 주문 리스트 조회
*SwaggerClient::OrderApi* | [**order_new**](docs/OrderApi.md#order_new) | **POST** /orders | 주문하기
*SwaggerClient::OrderApi* | [**order_orderbook**](docs/OrderApi.md#order_orderbook) | **GET** /orderbook | 시세 호가 정보(Orderbook) 조회
*SwaggerClient::TradeApi* | [**trade_ticker**](docs/TradeApi.md#trade_ticker) | **GET** /ticker | 시세 Ticker 조회
*SwaggerClient::TradeApi* | [**trade_ticks**](docs/TradeApi.md#trade_ticks) | **GET** /trades/ticks | 시세 체결 조회
*SwaggerClient::WithdrawApi* | [**withdraw_chance**](docs/WithdrawApi.md#withdraw_chance) | **GET** /withdraws/chance | 출금 가능 정보
*SwaggerClient::WithdrawApi* | [**withdraw_coin**](docs/WithdrawApi.md#withdraw_coin) | **POST** /withdraws/coin | 코인 출금하기
*SwaggerClient::WithdrawApi* | [**withdraw_info**](docs/WithdrawApi.md#withdraw_info) | **GET** /withdraw | 개별 출금 조회
*SwaggerClient::WithdrawApi* | [**withdraw_info_all**](docs/WithdrawApi.md#withdraw_info_all) | **GET** /withdraws | 출금 리스트 조회
*SwaggerClient::WithdrawApi* | [**withdraw_krw**](docs/WithdrawApi.md#withdraw_krw) | **POST** /withdraws/krw | 원화 출금하기


## Documentation for Models

 - [SwaggerClient::APIKey](docs/APIKey.md)
 - [SwaggerClient::Account](docs/Account.md)
 - [SwaggerClient::Ask](docs/Ask.md)
 - [SwaggerClient::AskAccount](docs/AskAccount.md)
 - [SwaggerClient::Bid](docs/Bid.md)
 - [SwaggerClient::BidAccount](docs/BidAccount.md)
 - [SwaggerClient::CandleDate](docs/CandleDate.md)
 - [SwaggerClient::CandleDays](docs/CandleDays.md)
 - [SwaggerClient::CandleMinutes](docs/CandleMinutes.md)
 - [SwaggerClient::Currency](docs/Currency.md)
 - [SwaggerClient::Deposit](docs/Deposit.md)
 - [SwaggerClient::DepositCompleteResponse](docs/DepositCompleteResponse.md)
 - [SwaggerClient::DepositTransferResponse](docs/DepositTransferResponse.md)
 - [SwaggerClient::Error](docs/Error.md)
 - [SwaggerClient::ErrorInfo](docs/ErrorInfo.md)
 - [SwaggerClient::Market](docs/Market.md)
 - [SwaggerClient::MarketInfo](docs/MarketInfo.md)
 - [SwaggerClient::MemberLevel](docs/MemberLevel.md)
 - [SwaggerClient::NewOrder](docs/NewOrder.md)
 - [SwaggerClient::Order](docs/Order.md)
 - [SwaggerClient::OrderChance](docs/OrderChance.md)
 - [SwaggerClient::OrderInfo](docs/OrderInfo.md)
 - [SwaggerClient::Orderbook](docs/Orderbook.md)
 - [SwaggerClient::OrderbookUnit](docs/OrderbookUnit.md)
 - [SwaggerClient::Ticker](docs/Ticker.md)
 - [SwaggerClient::Trade](docs/Trade.md)
 - [SwaggerClient::TradeTicks](docs/TradeTicks.md)
 - [SwaggerClient::Wallet](docs/Wallet.md)
 - [SwaggerClient::Withdraw](docs/Withdraw.md)
 - [SwaggerClient::WithdrawChance](docs/WithdrawChance.md)
 - [SwaggerClient::WithdrawCoin](docs/WithdrawCoin.md)
 - [SwaggerClient::WithdrawLimit](docs/WithdrawLimit.md)


## Documentation for Authorization


### Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

